<div align="center">
<img src="https://raw.githubusercontent.com/dartondox/assets/main/dox-logo.png" width="70" />
</br></br>
<div style="display:inliine-block">
<img src="https://img.shields.io/badge/Dart-0175C2?style=for-the-badge&logo=dart&logoColor=white" height="20"/> <img src="https://github.com/dartondox/dox/actions/workflows/test.yaml/badge.svg?branch=v1.x" height="20"/> <img src="https://img.shields.io/github/stars/dartondox/dox.svg" height="20"/> <img src="https://img.shields.io/github/forks/dartondox/dox.svg" height="20"/> <img src="https://img.shields.io/github/license/dartondox/dox.svg" height="20"/>
</div>
</div>

## About Dox

Dox is a powerful framework specifically developed for web application backend development with Dart. It provides a comprehensive set of tools and features to streamline the development process.

## Features

- **MultiThread HTTP Server**: Dox support multi-threaded HTTP server using isolates that can handle 10x concurrency requests with high speed.
- **Modular Architecture**: Dox follows a modular architecture, making it easy to extend and customize functionalities based on project requirements.
- **Scalability**: The framework is designed to handle high traffic and scale effortlessly as your web application grows.
- **Developer-Friendly**: With its intuitive APIs and clear documentation, Dox makes it easier for developers to create and maintain web applications.
- **Simple, fast routing**: Dox offers a simple and efficient routing system, allowing developers to define and handle routes easily for building robust web applications. 
- **ORM Support with Strong Query Builder**: Dox provides an ORM (Object-Relational Mapping) system along with a powerful query builder, enabling developers to interact with databases efficiently.
- **Validation of Request Data**: Dox includes built-in validation capabilities, allowing developers to validate incoming request data easily and ensure data integrity.
- **Database Migration**: The framework offers database migration support, allowing developers to manage and apply database schema changes seamlessly.
- **Web Socket**: Dox provides WebSocket support, enabling real-time communication and bidirectional data exchange between the server and clients.
- **CORS**: Dox includes Cross-Origin Resource Sharing (CORS) support, allowing developers to control and manage cross-origin requests for enhanced security.
- **CLI (Command-Line Interface)**: Dox provides a command-line interface with useful commands to streamline development tasks, such as creating migrations, generating models, and more.

## Documentation

For detailed information about the framework and its functionalities, refer to the [Dox Documentation](https://dartondox.dev).

## Security Vulnerabilities

Dox take the security of our framework seriously. If you identify any security vulnerabilities in our application, please notify us immediately by sending an email to support@dartondox.dev. We appreciate your responsible disclosure and will respond promptly to address and resolve any identified security issues. Your cooperation helps us maintain the integrity and safety of our software for all users.

## Contributing

We welcome contributions from the community! If you'd like to contribute to the Dox framework, please fork the repo and PR to us. Please visit [contribution guide](/docs/others/contribute.md) for more information.

## License

This project is licensed under the [MIT License](LICENSE).

## Community

<a href="https://discord.gg/pBfWrsvBSV"><img src="https://img.shields.io/badge/Discord-7289DA?style=for-the-badge&logo=discord&logoColor=white"></a>
